'''
# in place
# LET OP:
# nu zal de oorspronkelijke lijst uit het
# hoofdprogramma ook effectief aangepast zijn;
# dat is een neveneffect dat we liever NIET hebben
# (Omdat we afspraken dat een functie maar EEN ding doet:
#  een antwoord TERUGGEVEN, en GEEN stiekeme aanpassing
#  aan de parameter zelf...)
# Ga dus voor de tweede oplossing, niet in place

def interpolatie(lijst):
    lengte = len(lijst)
    for i in range(lengte-1):
        lijst.append(0)
    for i in range(2*(lengte-1),0,-2):
        lijst[i] = lijst[i//2]
        lijst[i-1] = (lijst[i//2] + lijst[i//2-1])/2
    return lijst
'''

# niet in place, met nieuwe lijst    
def interpolatie(lijst):
    nieuw = []
    # De lus is nuttig voor elk element dat 'over dezelfde kam
    # geschoren moet worden'. Het laatste element uit de lijst
    # hoort daar niet bij, dus stopt de lus één stapje vroeger
    # dan normaal (vandaar  -1  in de range).
    for i in range(len(lijst)-1):
        nieuw.append(lijst[i])
        nieuw.append( (lijst[i] + lijst[i+1]) / 2)
    # Het laatste element krijgt een aparte behandeling,
    # dus BUITEN de lus.    
    nieuw.append(lijst[-1])    
    return nieuw

waarden = [10.0,20.0,40.0,100.0]
print(waarden)
print(interpolatie(waarden))
print(interpolatie(interpolatie(waarden)))